#line 1 "C:/Users/uemin/Desktop/mikroC/MPU6050 Ivme ve Gyro Sensoru/main.c"
#line 1 "c:/users/uemin/desktop/mikroc/mpu6050 ivme ve gyro sensoru/mpu6050.c"
#line 114 "c:/users/uemin/desktop/mikroc/mpu6050 ivme ve gyro sensoru/mpu6050.c"
unsigned short MPU6050_ADDRESS=0xD0;


int accelX_Offset=0,accelY_Offset=0,accelZ_Offset=0,gyroX_Offset=0,gyroY_Offset=0,gyroZ_Offset=0;


void MPU6050_Write(unsigned short address, unsigned short value){
 I2C1_Start();
 I2C1_Wr(MPU6050_ADDRESS);
 I2C1_Wr(address);
 I2C1_Wr(value);
 I2C1_Stop();
}


void MPU6050_Init(){

 delay_ms(100);


 MPU6050_Write( 0x6B , 0x00);


 MPU6050_Write( 0x1A , 0x06);


 MPU6050_Write( 0x1B , 0x18);


 MPU6050_Write( 0x1C , 0x18);
}


void MPU6050_SetOffset(int accelX, int accelY, int accelZ, int gyroX, int gyroY, int gyroZ){
 accelX_Offset=accelX;
 accelY_Offset=accelY;
 accelZ_Offset=accelZ;
 gyroX_Offset=gyroX;
 gyroY_Offset=gyroY;
 gyroZ_Offset=gyroZ;
}


void MPU6050_Read(int *accelX, int *accelY, int *accelZ, int *temp, int *gyroX, int *gyroY, int *gyroZ){

 I2C1_Start();
 I2C1_Wr(MPU6050_ADDRESS);
 I2C1_Wr( 0x3B );
 I2C1_Stop();
 I2C1_Start();
 I2C1_Wr(MPU6050_ADDRESS+1);

 *accelX = (I2C1_Rd(1)<<8) | I2C1_Rd(1);
 *accelY = (I2C1_Rd(1)<<8) | I2C1_Rd(1);
 *accelZ = (I2C1_Rd(1)<<8) | I2C1_Rd(1);
 *temp = (I2C1_Rd(1)<<8) | I2C1_Rd(1);
 *gyroX = (I2C1_Rd(1)<<8) | I2C1_Rd(1);
 *gyroY = (I2C1_Rd(1)<<8) | I2C1_Rd(1);
 *gyroZ = (I2C1_Rd(1)<<8) | I2C1_Rd(0);

 I2C1_Stop();
 *accelX-=accelX_Offset;
 *accelY-=accelY_Offset;
 *accelZ-=accelZ_Offset;
 *temp = (*temp/340)+36;
 *gyroX-=gyroX_Offset;
 *gyroY-=gyroY_Offset;
 *gyroZ-=gyroZ_Offset;
}
#line 4 "C:/Users/uemin/Desktop/mikroC/MPU6050 Ivme ve Gyro Sensoru/main.c"
sbit LED at LATA4_bit;


int accelX, accelY, accelZ, temp, gyroX, gyroY, gyroZ;


void SendHC06(int value){
 char txt[7];
 IntToStr(value,txt);
 UART_Write_Text(txt);
 UART_Write_Text(" ");
}

void main() {

 TRISA=0b00000000;
 TRISB=0b00000000;
 TRISC=0b10000000;
 TRISD=0b00000000;
 TRISE=0b00000000;


 ANSELA=0b00000000;
 ANSELB=0b00000000;
 ANSELC=0b00000000;
 ANSELD=0b00000000;
 ANSELE=0b00000000;


 LATA=0x00;
 LATB=0x00;
 LATC=0x00;
 LATD=0x00;
 LATE=0x00;

 UART1_Init(9600);


 I2C1_Init(400000);
 MPU6050_Init();


 MPU6050_Read(&accelX, &accelY, &accelZ, &temp, &gyroX, &gyroY, &gyroZ);
 MPU6050_SetOffset(accelX,accelY,accelZ,gyroX,gyroY,gyroZ);


 while(1){
 delay_ms(100);

 MPU6050_Read(&accelX, &accelY, &accelZ, &temp, &gyroX, &gyroY, &gyroZ);

 SendHC06(accelX);
 SendHC06(accelY);
 SendHC06(temp);
 SendHC06(gyroX);
 SendHC06(gyroY);
 SendHC06(gyroZ);
 UART_Write_Text("\r\n");

 LED=!LED;
 }
}
